#ifndef __KKRG_IPC__
#define __KKRG_IPC__

#include <linux/init.h>
#include <linux/lockdep.h>
#include <asm/semaphore.h>
#include <linux/mutex.h>
#include <linux/msg.h>
#include <linux/ipc_util.h>

struct ipc_id {
       struct kern_ipc_perm* p;
};

/** Kerrighed Hooks **/

extern int (*kh_ipc_get_max_id)(struct ipc_namespace *ns, struct ipc_ids* ids);
extern int (*kh_get_ipc_id)(struct ipc_ids* ids, int size);
extern int (*kh_ipc_findkey)(struct ipc_ids* ids, key_t key);


int grow_ary(struct ipc_ids* ids, int newsize);

extern struct ipc_namespace init_ipc_ns;

extern struct lock_class_key ipcid_lock_key;

#endif // __KKRG_IPC__
